Whamcloud - gitweb
b=16252
[fs/lustre-release.git] / lustre / tests / test-framework.sh
1 #!/bin/bash
2 # vim:expandtab:shiftwidth=4:softtabstop=4:tabstop=4:
3
4 trap 'print_summary && echo "test-framework exiting on error"' ERR
5 set -e
6 #set -x
7
8
9 export REFORMAT=${REFORMAT:-""}
10 export VERBOSE=false
11 export GMNALNID=${GMNALNID:-/usr/sbin/gmlndnid}
12 export CATASTROPHE=${CATASTROPHE:-/proc/sys/lnet/catastrophe}
13 export GSS=false
14 export GSS_KRB5=false
15 export GSS_PIPEFS=false
16 export IDENTITY_UPCALL=default
17 #export PDSH="pdsh -S -Rssh -w"
18
19 # eg, assert_env LUSTRE MDSNODES OSTNODES CLIENTS
20 assert_env() {
21     local failed=""
22     for name in $@; do
23         if [ -z "${!name}" ]; then
24             echo "$0: $name must be set"
25             failed=1
26         fi
27     done
28     [ $failed ] && exit 1 || true
29 }
30
31 assert_DIR () {
32     local failed=""
33     [ -z "`echo :$DIR: | grep :$MOUNT:`" ] && \
34         failed=1 && echo "DIR not in $MOUNT. Aborting."
35     [ -z "`echo :$DIR1: | grep :$MOUNT1:`" ] && \
36         failed=1 && echo "DIR1 not in $MOUNT1. Aborting."
37     [ -z "`echo :$DIR2: | grep :$MOUNT2:`" ] && \
38         failed=1 && echo "DIR2 not in $MOUNT2. Aborting"
39
40     [ -n "$failed" ] && exit 99 || true
41 }
42
43 usage() {
44     echo "usage: $0 [-r] [-f cfgfile]"
45     echo "       -r: reformat"
46
47     exit
48 }
49
50 print_summary () {
51     [ "$TESTSUITE" == "lfscktest" ] && return 0
52     [ -n "$ONLY" ] && echo "WARNING: ONLY is set to ${ONLY}."
53     local form="%-13s %-17s %s\n"
54     printf "$form" "status" "script" "skipped tests E(xcluded) S(low)"
55     echo "------------------------------------------------------------------------------------"
56     for O in $TESTSUITE_LIST; do
57         local skipped=""
58         local slow=""
59         local o=$(echo $O | tr "[:upper:]" "[:lower:]")
60         o=${o//_/-}
61         o=${o//tyn/tyN}
62         local log=${TMP}/${o}.log
63         [ -f $log ] && skipped=$(grep excluded $log | awk '{ printf " %s", $3 }' | sed 's/test_//g')
64         [ -f $log ] && slow=$(grep SLOW $log | awk '{ printf " %s", $3 }' | sed 's/test_//g')
65         [ "${!O}" = "done" ] && \
66             printf "$form" "Done" "$O" "E=$skipped" && \
67             [ -n "$slow" ] && printf "$form" "-" "-" "S=$slow"
68
69     done
70
71     for O in $TESTSUITE_LIST; do
72         [ "${!O}" = "no" ] && \
73             printf "$form" "Skipped" "$O" ""
74     done
75
76     for O in $TESTSUITE_LIST; do
77         [ "${!O}" = "done" -o "${!O}" = "no" ] || \
78             printf "$form" "UNFINISHED" "$O" ""
79     done
80 }
81
82 init_test_env() {
83     export LUSTRE=`absolute_path $LUSTRE`
84     export TESTSUITE=`basename $0 .sh`
85
86     [ -d /r ] && export ROOT=${ROOT:-/r}
87     export TMP=${TMP:-$ROOT/tmp}
88     export TESTSUITELOG=${TMP}/${TESTSUITE}.log
89     export HOSTNAME=${HOSTNAME:-`hostname`}
90     if ! echo $PATH | grep -q $LUSTRE/utils; then
91         export PATH=$PATH:$LUSTRE/utils
92     fi
93     if ! echo $PATH | grep -q $LUSTRE/utils/gss; then
94         export PATH=$PATH:$LUSTRE/utils/gss
95     fi
96     if ! echo $PATH | grep -q $LUSTRE/tests; then
97         export PATH=$PATH:$LUSTRE/tests
98     fi
99     export LCTL=${LCTL:-"$LUSTRE/utils/lctl"}
100     [ ! -f "$LCTL" ] && export LCTL=$(which lctl)
101     export LFS=${LFS:-"$LUSTRE/utils/lfs"}
102     [ ! -f "$LFS" ] && export LFS=$(which lfs)
103     export L_GETIDENTITY=${L_GETIDENTITY:-"$LUSTRE/utils/l_getidentity"}
104     if [ ! -f "$L_GETIDENTITY" ]; then
105         if `which l_getidentity > /dev/null 2>&1`; then
106             export L_GETIDENTITY=$(which l_getidentity)
107         else
108             export L_GETIDENTITY=NONE
109         fi
110     fi
111     export MKFS=${MKFS:-"$LUSTRE/utils/mkfs.lustre"}
112     [ ! -f "$MKFS" ] && export MKFS=$(which mkfs.lustre)
113     export TUNEFS=${TUNEFS:-"$LUSTRE/utils/tunefs.lustre"}
114     [ ! -f "$TUNEFS" ] && export TUNEFS=$(which tunefs.lustre)
115     export CHECKSTAT="${CHECKSTAT:-"checkstat -v"} "
116     export FSYTPE=${FSTYPE:-"ldiskfs"}
117     export NAME=${NAME:-local}
118     export LPROC=/proc/fs/lustre
119     export LGSSD=${LGSSD:-"$LUSTRE/utils/gss/lgssd"}
120     [ "$GSS_PIPEFS" = "true" ] && [ ! -f "$LGSSD" ] && \
121         export LGSSD=$(which lgssd)
122     export LSVCGSSD=${LSVCGSSD:-"$LUSTRE/utils/gss/lsvcgssd"}
123     [ ! -f "$LSVCGSSD" ] && export LSVCGSSD=$(which lsvcgssd)
124     export KRB5DIR=${KRB5DIR:-"/usr/kerberos"}
125     export DIR2
126     export SAVE_PWD=${SAVE_PWD:-$LUSTRE/tests}
127     export AT_MAX_PATH
128
129     if [ "$ACCEPTOR_PORT" ]; then
130         export PORT_OPT="--port $ACCEPTOR_PORT"
131     fi
132
133     case "x$SEC" in
134         xkrb5*)
135             echo "Using GSS/krb5 ptlrpc security flavor"
136             which lgss_keyring > /dev/null 2>&1 || \
137                 error "built with gss disabled! SEC=$SEC"
138             GSS=true
139             GSS_KRB5=true
140             ;;
141     esac
142
143     case "x$IDUP" in
144         xtrue)
145             IDENTITY_UPCALL=true
146             ;;
147         xfalse)
148             IDENTITY_UPCALL=false
149             ;;
150     esac
151
152     # Paths on remote nodes, if different
153     export RLUSTRE=${RLUSTRE:-$LUSTRE}
154     export RPWD=${RPWD:-$PWD}
155     export I_MOUNTED=${I_MOUNTED:-"no"}
156
157     # command line
158
159     while getopts "rvf:" opt $*; do
160         case $opt in
161             f) CONFIG=$OPTARG;;
162             r) REFORMAT=--reformat;;
163             v) VERBOSE=true;;
164             \?) usage;;
165         esac
166     done
167
168     shift $((OPTIND - 1))
169     ONLY=${ONLY:-$*}
170
171     [ "$TESTSUITELOG" ] && rm -f $TESTSUITELOG || true
172     rm -f $TMP/*active
173
174 }
175
176 load_module() {
177     EXT=".ko"
178     module=$1
179     shift
180     BASE=`basename $module $EXT`
181     lsmod | grep -q ${BASE} || \
182       if [ -f ${LUSTRE}/${module}${EXT} ]; then
183         insmod ${LUSTRE}/${module}${EXT} $@
184     else
185         # must be testing a "make install" or "rpm" installation
186         # note failed to load ptlrpc_gss is considered not fatal
187         if [ "$BASE" == "ptlrpc_gss" ]; then
188             modprobe $BASE $@ 2>/dev/null || echo "gss/krb5 is not supported"
189         else
190             modprobe $BASE $@
191         fi
192     fi
193 }
194
195 load_modules() {
196     if [ -n "$MODPROBE" ]; then
197         # use modprobe
198     return 0
199     fi
200     if [ "$HAVE_MODULES" = true ]; then
201     # we already loaded
202         return 0
203     fi
204     HAVE_MODULES=true
205
206     echo Loading modules from $LUSTRE
207     load_module ../libcfs/libcfs/libcfs
208     [ "$PTLDEBUG" ] && lctl set_param debug=$PTLDEBUG
209     [ "$SUBSYSTEM" ] && lctl set_param subsystem_debug=${SUBSYSTEM# }
210     [ -f /etc/modprobe.conf ] && MODPROBECONF=/etc/modprobe.conf
211     [ -f /etc/modprobe.d/Lustre ] && MODPROBECONF=/etc/modprobe.d/Lustre
212     [ -z "$LNETOPTS" -a -n "$MODPROBECONF" ] && \
213         LNETOPTS=$(awk '/^options lnet/ { print $0}' $MODPROBECONF | sed 's/^options lnet //g')
214     echo "lnet options: '$LNETOPTS'"
215     # note that insmod will ignore anything in modprobe.conf
216     load_module ../lnet/lnet/lnet $LNETOPTS
217     LNETLND=${LNETLND:-"socklnd/ksocklnd"}
218     load_module ../lnet/klnds/$LNETLND
219     load_module lvfs/lvfs
220     load_module obdclass/obdclass
221     load_module ptlrpc/ptlrpc
222     load_module ptlrpc/gss/ptlrpc_gss
223     # Now, some modules depend on lquota without USE_QUOTA check,
224     # will fix later. Disable check "$USE_QUOTA" = "yes" temporary.
225     #[ "$USE_QUOTA" = "yes" ] && load_module quota/lquota
226     load_module quota/lquota
227     load_module fid/fid
228     load_module fld/fld
229     load_module lmv/lmv
230     load_module mdc/mdc
231     load_module osc/osc
232     load_module lov/lov
233     load_module mgc/mgc
234     if [ -z "$CLIENTONLY" ] && [ -z "$CLIENTMODSONLY" ]; then
235         grep -q crc16 /proc/kallsyms || { modprobe crc16 2>/dev/null || true; }
236         [ "$FSTYPE" = "ldiskfs" ] && load_module ../ldiskfs/ldiskfs/ldiskfs
237         load_module mgs/mgs
238         load_module mds/mds
239         load_module mdd/mdd
240         load_module mdt/mdt
241         load_module lvfs/fsfilt_$FSTYPE
242         load_module cmm/cmm
243         load_module osd/osd
244         load_module ost/ost
245         load_module obdfilter/obdfilter
246     fi
247
248     load_module llite/lustre
249     load_module llite/llite_lloop
250     rm -f $TMP/ogdb-$HOSTNAME
251     OGDB=$TMP
252     [ -d /r ] && OGDB="/r/tmp"
253     $LCTL modules > $OGDB/ogdb-$HOSTNAME
254
255     # 'mount' doesn't look in $PATH, just sbin
256     [ -f $LUSTRE/utils/mount.lustre ] && cp $LUSTRE/utils/mount.lustre /sbin/. || true
257 }
258
259 RMMOD=rmmod
260 if [ `uname -r | cut -c 3` -eq 4 ]; then
261     RMMOD="modprobe -r"
262 fi
263
264 wait_for_lnet() {
265     local UNLOADED=0
266     local WAIT=0
267     local MAX=60
268     MODULES=$($LCTL modules | awk '{ print $2 }')
269     while [ -n "$MODULES" ]; do
270     sleep 5
271     $RMMOD $MODULES > /dev/null 2>&1 || true
272     MODULES=$($LCTL modules | awk '{ print $2 }')
273         if [ -z "$MODULES" ]; then
274         return 0
275         else
276             WAIT=$((WAIT + 5))
277             echo "waiting, $((MAX - WAIT)) secs left"
278         fi
279         if [ $WAIT -eq $MAX ]; then
280             echo "LNET modules $MODULES will not unload"
281         lsmod
282             return 3
283         fi
284     done
285 }
286
287 unload_dep_module() {
288     #lsmod output
289     #libcfs                107852  17 llite_lloop,lustre,obdfilter,ost,...
290     local MODULE=$1
291     local DEPS=$(lsmod | awk '($1 == "'$MODULE'") { print $4 }' | tr ',' ' ')
292     for SUBMOD in $DEPS; do
293         unload_dep_module $SUBMOD
294     done
295     [ "$MODULE" = "libcfs" ] && $LCTL dk $TMP/debug || true
296     $RMMOD $MODULE || true
297 }
298
299 unload_modules() {
300     wait_exit_ST client # bug 12845
301
302     lsmod | grep libcfs > /dev/null && $LCTL dl
303     unload_dep_module $FSTYPE
304     unload_dep_module libcfs
305
306     local MODULES=$($LCTL modules | awk '{ print $2 }')
307     if [ -n "$MODULES" ]; then
308         echo "Modules still loaded: "
309         echo $MODULES 
310         if [ "$(lctl dl)" ]; then
311             echo "Lustre still loaded"
312             lctl dl || true
313             lsmod
314             return 2
315         else
316             echo "Lustre stopped but LNET is still loaded, waiting..."
317             wait_for_lnet || return 3
318         fi
319
320     fi
321     HAVE_MODULES=false
322
323     LEAK_LUSTRE=$(dmesg | tail -n 30 | grep "obd mem.*leaked" || true)
324     LEAK_PORTALS=$(dmesg | tail -n 20 | grep "Portals memory leaked" || true)
325     if [ "$LEAK_LUSTRE" -o "$LEAK_PORTALS" ]; then
326         echo "$LEAK_LUSTRE" 1>&2
327         echo "$LEAK_PORTALS" 1>&2
328         mv $TMP/debug $TMP/debug-leak.`date +%s` || true
329         echo "Memory leaks detected"
330         [ -n "$IGNORE_LEAK" ] && echo "ignoring leaks" && return 0
331         return 254
332     fi
333     echo "modules unloaded."
334     return 0
335 }
336
337 check_gss_daemon_facet() {
338     facet=$1
339     dname=$2
340
341     num=`do_facet $facet ps -o cmd -C $dname | grep $dname | wc -l`
342     if [ $num -ne 1 ]; then
343         echo "$num instance of $dname on $facet"
344         return 1
345     fi
346     return 0
347 }
348
349 send_sigint() {
350     local facet=$1
351     shift
352     do_facet $facet "killall -2 $@ 2>/dev/null || true"
353 }
354
355 start_gss_daemons() {
356     # starting on MDT
357     for num in `seq $MDSCOUNT`; do
358         do_facet mds$num "$LSVCGSSD -v"
359         if $GSS_PIPEFS; then
360             do_facet mds$num "$LGSSD -v"
361         fi
362     done
363     # starting on OSTs
364     for num in `seq $OSTCOUNT`; do
365         do_facet ost$num "$LSVCGSSD -v"
366     done
367     # starting on client
368     # FIXME: is "client" the right facet name?
369     if $GSS_PIPEFS; then
370         do_facet client "$LGSSD -v"
371     fi
372
373     # wait daemons entering "stable" status
374     sleep 5
375
376     #
377     # check daemons are running
378     #
379     for num in `seq $MDSCOUNT`; do
380         check_gss_daemon_facet mds$num lsvcgssd
381         if $GSS_PIPEFS; then
382             check_gss_daemon_facet mds$num lgssd
383         fi
384     done
385     for num in `seq $OSTCOUNT`; do
386         check_gss_daemon_facet ost$num lsvcgssd
387     done
388     if $GSS_PIPEFS; then
389         check_gss_daemon_facet client lgssd
390     fi
391 }
392
393 stop_gss_daemons() {
394     for num in `seq $MDSCOUNT`; do
395         send_sigint mds$num lsvcgssd lgssd
396     done
397     for num in `seq $OSTCOUNT`; do
398         send_sigint ost$num lsvcgssd
399     done
400     send_sigint client lgssd
401 }
402
403 init_gss() {
404     if $GSS; then
405         start_gss_daemons
406     fi
407 }
408
409 cleanup_gss() {
410     if $GSS; then
411         stop_gss_daemons
412         # maybe cleanup credential cache?
413     fi
414 }
415
416 mdsdevlabel() {
417     local num=$1
418     local device=`mdsdevname $num`
419     local label=`do_facet mds$num "e2label ${device}" | grep -v "CMD: "`
420     echo -n $label
421 }
422
423 ostdevlabel() {
424     local num=$1
425     local device=`ostdevname $num`
426     local label=`do_facet ost$num "e2label ${device}" | grep -v "CMD: "`
427     echo -n $label
428 }
429
430 # Facet functions
431 mount_facet() {
432     local facet=$1
433     shift
434     local dev=${facet}_dev
435     local opt=${facet}_opt
436     echo "Starting ${facet}: ${!opt} $@ ${!dev} ${MOUNT%/*}/${facet}"
437     do_facet ${facet} mount -t lustre ${!opt} $@ ${!dev} ${MOUNT%/*}/${facet}     
438     RC=${PIPESTATUS[0]}
439     if [ $RC -ne 0 ]; then
440         echo "mount -t lustre $@ ${!dev} ${MOUNT%/*}/${facet}"
441         echo "Start of ${!dev} on ${facet} failed ${RC}"
442     else
443         do_facet ${facet} "lctl set_param debug=$PTLDEBUG; \
444             lctl set_param subsystem_debug=${SUBSYSTEM# }; \
445             lctl set_param debug_mb=${DEBUG_SIZE}; \
446             sync"
447  
448         label=$(do_facet ${facet} "e2label ${!dev}")
449         [ -z "$label" ] && echo no label for ${!dev} && exit 1
450         eval export ${facet}_svc=${label}
451         echo Started ${label}
452     fi
453     return $RC
454 }
455
456 # start facet device options
457 start() {
458     facet=$1
459     shift
460     device=$1
461     shift
462     eval export ${facet}_dev=${device}
463     eval export ${facet}_opt=\"$@\"
464     do_facet ${facet} mkdir -p ${MOUNT%/*}/${facet}
465     mount_facet ${facet}
466     RC=$?
467     return $RC
468 }
469
470 stop() {
471     local running
472     facet=$1
473     shift
474     HOST=`facet_active_host $facet`
475     [ -z $HOST ] && echo stop: no host for $facet && return 0
476
477     running=$(do_facet ${facet} "grep -c ${MOUNT%/*}/${facet}' ' /proc/mounts") || true
478     if [ ${running} -ne 0 ]; then
479         echo "Stopping ${MOUNT%/*}/${facet} (opts:$@)"
480         do_facet ${facet} umount -d $@ ${MOUNT%/*}/${facet}
481     fi
482
483     # umount should block, but we should wait for unrelated obd's
484     # like the MGS or MGC to also stop.
485     wait_exit_ST ${facet}
486 }
487
488 zconf_mount() {
489     local OPTIONS
490     local client=$1
491     local mnt=$2
492     # Only supply -o to mount if we have options
493     if [ -n "$MOUNTOPT" ]; then
494         OPTIONS="-o $MOUNTOPT"
495     fi
496     local device=$MGSNID:/$FSNAME
497     if [ -z "$mnt" -o -z "$FSNAME" ]; then
498         echo Bad zconf mount command: opt=$OPTIONS dev=$device mnt=$mnt
499         exit 1
500     fi
501
502     echo "Starting client: $client: $OPTIONS $device $mnt"
503     do_node $client mkdir -p $mnt
504     do_node $client mount -t lustre $OPTIONS $device $mnt || return 1
505
506     do_node $client "lctl set_param debug=$PTLDEBUG;
507         lctl set_param subsystem_debug=${SUBSYSTEM# };
508         lctl set_param debug_mb=${DEBUG_SIZE}"
509     [ -d /r ] && $LCTL modules > /r/tmp/ogdb-$HOSTNAME
510     return 0
511 }
512
513 zconf_umount() {
514     local client=$1
515     local mnt=$2
516     [ "$3" ] && force=-f
517     local running=$(do_node $client "grep -c $mnt' ' /proc/mounts") || true
518     if [ $running -ne 0 ]; then
519         echo "Stopping client $client $mnt (opts:$force)"
520         lsof | grep "$mnt" || true
521         do_node $client umount $force $mnt
522     fi
523 }
524
525 # mount clients if not mouted
526 zconf_mount_clients() {
527     local OPTIONS
528     local clients=$1
529     local mnt=$2
530
531
532     # Only supply -o to mount if we have options
533     if [ -n "$MOUNTOPT" ]; then
534         OPTIONS="-o $MOUNTOPT"
535     fi
536     local device=$MGSNID:/$FSNAME
537     if [ -z "$mnt" -o -z "$FSNAME" ]; then
538         echo Bad zconf mount command: opt=$OPTIONS dev=$device mnt=$mnt
539         exit 1
540     fi
541
542     echo "Starting client $clients: $OPTIONS $device $mnt"
543     do_nodes $clients "mount | grep $mnt || { mkdir -p $mnt && mount -t lustre $OPTIONS $device $mnt || false; }"
544
545     echo "Started clients $clients: "
546     do_nodes $clients "mount | grep $mnt"
547
548     do_nodes $clients "lctl set_param debug=$PTLDEBUG;
549         lctl set_param subsystem_debug=${SUBSYSTEM# };
550         lctl set_param debug_mb=${DEBUG_SIZE};"
551
552     return 0
553 }
554
555 zconf_umount_clients() {
556     local clients=$1
557     local mnt=$2
558     [ "$3" ] && force=-f
559
560     echo "Umounting clients: $clients"
561     echo "Stopping clients: $clients $mnt (opts:$force)"
562     do_nodes $clients umount $force $mnt
563 }
564
565 shutdown_facet() {
566     facet=$1
567     if [ "$FAILURE_MODE" = HARD ]; then
568         $POWER_DOWN `facet_active_host $facet`
569         sleep 2
570     elif [ "$FAILURE_MODE" = SOFT ]; then
571         stop $facet
572     fi
573 }
574
575 reboot_facet() {
576     facet=$1
577     if [ "$FAILURE_MODE" = HARD ]; then
578         $POWER_UP `facet_active_host $facet`
579     else
580         sleep 10
581     fi
582 }
583
584 # verify that lustre actually cleaned up properly
585 cleanup_check() {
586     [ -f $CATASTROPHE ] && [ `cat $CATASTROPHE` -ne 0 ] && \
587         error "LBUG/LASSERT detected"
588     BUSY=`dmesg | grep -i destruct || true`
589     if [ "$BUSY" ]; then
590         echo "$BUSY" 1>&2
591         [ -e $TMP/debug ] && mv $TMP/debug $TMP/debug-busy.`date +%s`
592         exit 205
593     fi
594     LEAK_LUSTRE=`dmesg | tail -n 30 | grep "obd mem.*leaked" || true`
595     LEAK_PORTALS=`dmesg | tail -n 20 | grep "Portals memory leaked" || true`
596     if [ "$LEAK_LUSTRE" -o "$LEAK_PORTALS" ]; then
597         echo "$0: $LEAK_LUSTRE" 1>&2
598         echo "$0: $LEAK_PORTALS" 1>&2
599         echo "$0: Memory leak(s) detected..." 1>&2
600         mv $TMP/debug $TMP/debug-leak.`date +%s`
601         exit 204
602     fi
603
604     [ "`lctl dl 2> /dev/null | wc -l`" -gt 0 ] && lctl dl && \
605         echo "$0: lustre didn't clean up..." 1>&2 && return 202 || true
606
607     if [ "`/sbin/lsmod 2>&1 | egrep 'lnet|libcfs'`" ]; then
608         echo "$0: modules still loaded..." 1>&2
609         /sbin/lsmod 1>&2
610         return 203
611     fi
612     return 0
613 }
614
615 wait_delete_completed () {
616     local TOTALPREV=`lctl get_param -n osc.*.kbytesavail | \
617                      awk 'BEGIN{total=0}; {total+=$1}; END{print total}'`
618
619     local WAIT=0
620     local MAX_WAIT=20
621     while [ "$WAIT" -ne "$MAX_WAIT" ]; do
622         sleep 1
623         TOTAL=`lctl get_param -n osc.*.kbytesavail | \
624                awk 'BEGIN{total=0}; {total+=$1}; END{print total}'`
625         [ "$TOTAL" -eq "$TOTALPREV" ] && break
626         echo "Waiting delete completed ... prev: $TOTALPREV current: $TOTAL "
627         TOTALPREV=$TOTAL
628         WAIT=$(( WAIT + 1))
629     done
630     echo "Delete completed."
631 }
632
633 wait_for_host() {
634     HOST=$1
635     check_network "$HOST" 900
636     while ! do_node $HOST "ls -d $LUSTRE " > /dev/null; do sleep 5; done
637 }
638
639 wait_for() {
640     facet=$1
641     HOST=`facet_active_host $facet`
642     wait_for_host $HOST
643 }
644
645 wait_mds_recovery_done () {
646     local timeout=`do_facet mds lctl get_param  -n timeout`
647 #define OBD_RECOVERY_TIMEOUT (obd_timeout * 5 / 2)
648 # as we are in process of changing obd_timeout in different ways
649 # let's set MAX longer than that
650     MAX=$(( timeout * 4 ))
651     WAIT=0
652     while [ $WAIT -lt $MAX ]; do
653         STATUS=`do_facet $SINGLEMDS "lctl get_param -n mdt.*-MDT*.recovery_status | grep status"`
654         echo $STATUS | grep COMPLETE && return 0
655         sleep 5
656         WAIT=$((WAIT + 5))
657         echo "Waiting $(($MAX - $WAIT)) secs for MDS recovery done"
658     done
659     echo "MDS recovery not done in $MAX sec"
660     return 1
661 }
662
663 wait_exit_ST () {
664     local facet=$1
665
666     local WAIT=0
667     local INTERVAL=1
668     # conf-sanity 31 takes a long time cleanup
669     while [ $WAIT -lt 300 ]; do
670         running=$(do_facet ${facet} "lsmod | grep lnet > /dev/null && lctl dl | grep ' ST '") || true
671         [ -z "${running}" ] && return 0
672         echo "waited $WAIT for${running}"
673         [ $INTERVAL -lt 64 ] && INTERVAL=$((INTERVAL + INTERVAL))
674         sleep $INTERVAL
675         WAIT=$((WAIT + INTERVAL))
676     done
677     echo "service didn't stop after $WAIT seconds.  Still running:"
678     echo ${running}
679     return 1
680 }
681
682 wait_remote_prog () {
683    local prog=$1
684    local WAIT=0
685    local INTERVAL=5
686    local rc=0
687
688    [ "$PDSH" = "no_dsh" ] && return 0
689    
690    while [ $WAIT -lt $2 ]; do
691         running=$(ps uax | grep "$PDSH.*$prog.*$MOUNT" | grep -v grep)
692         [ -z "${running}" ] && return 0
693         echo "waited $WAIT for: "
694         echo "$running"
695         [ $INTERVAL -lt 60 ] && INTERVAL=$((INTERVAL + INTERVAL))
696         sleep $INTERVAL
697         WAIT=$((WAIT + INTERVAL))
698     done
699     local pids=$(ps  uax | grep "$PDSH.*$prog.*$MOUNT" | grep -v grep | awk '{print $2}')
700     [ -z "$pids" ] && return 0
701     echo "$PDSH processes still exists after $WAIT seconds.  Still running: $pids"
702     for pid in $pids; do
703         cat /proc/${pid}/status || true
704         cat /proc/${pid}/wchan || true
705         echo "Killing $pid"
706         kill -9 $pid || true
707         sleep 1
708         ps -P $pid && rc=1 
709     done
710
711     return $rc
712 }
713
714 client_df() {
715     # not every config has many clients
716     if [ ! -z "$CLIENTS" ]; then
717         $PDSH $CLIENTS "df $MOUNT" > /dev/null
718     else
719         df $MOUNT > /dev/null
720     fi
721 }
722
723 client_reconnect() {
724     uname -n >> $MOUNT/recon
725     if [ ! -z "$CLIENTS" ]; then
726         $PDSH $CLIENTS "df $MOUNT; uname -n >> $MOUNT/recon" > /dev/null
727     fi
728     echo Connected clients:
729     cat $MOUNT/recon
730     ls -l $MOUNT/recon > /dev/null
731     rm $MOUNT/recon
732 }
733
734 facet_failover() {
735     facet=$1
736     echo "Failing $facet on node `facet_active_host $facet`"
737     shutdown_facet $facet
738     reboot_facet $facet
739     client_df &
740     DFPID=$!
741     echo "df pid is $DFPID"
742     change_active $facet
743     TO=`facet_active_host $facet`
744     echo "Failover $facet to $TO"
745     wait_for $facet
746     mount_facet $facet || error "Restart of $facet failed"
747 }
748
749 obd_name() {
750     local facet=$1
751 }
752
753 replay_barrier() {
754     local facet=$1
755     do_facet $facet sync
756     df $MOUNT
757     local svc=${facet}_svc
758     do_facet $facet $LCTL --device %${!svc} readonly
759     do_facet $facet $LCTL --device %${!svc} notransno
760     do_facet $facet $LCTL mark "$facet REPLAY BARRIER on ${!svc}"
761     $LCTL mark "local REPLAY BARRIER on ${!svc}"
762 }
763
764 replay_barrier_nodf() {
765     local facet=$1    echo running=${running}
766     do_facet $facet sync
767     local svc=${facet}_svc
768     echo Replay barrier on ${!svc}
769     do_facet $facet $LCTL --device %${!svc} readonly
770     do_facet $facet $LCTL --device %${!svc} notransno
771     do_facet $facet $LCTL mark "$facet REPLAY BARRIER on ${!svc}"
772     $LCTL mark "local REPLAY BARRIER on ${!svc}"
773 }
774
775 mds_evict_client() {
776     UUID=`lctl get_param -n mdc.${mds1_svc}-mdc-*.uuid`
777     do_facet mds1 "lctl set_param -n mdt.${mds1_svc}.evict_client $UUID"
778 }
779
780 ost_evict_client() {
781     UUID=`lctl get_param -n devices| grep ${ost1_svc}-osc- | egrep -v 'MDT' | awk '{print $5}'`
782     do_facet ost1 "lctl set_param -n obdfilter.${ost1_svc}.evict_client $UUID"
783 }
784
785 fail() {
786     facet_failover $* || error "failover: $?"
787     df $MOUNT || error "post-failover df: $?"
788 }
789
790 fail_nodf() {
791         local facet=$1
792         facet_failover $facet
793 }
794
795 fail_abort() {
796     local facet=$1
797     stop $facet
798     change_active $facet
799     mount_facet $facet -o abort_recovery
800     df $MOUNT || echo "first df failed: $?"
801     sleep 1
802     df $MOUNT || error "post-failover df: $?"
803 }
804
805 do_lmc() {
806     echo There is no lmc.  This is mountconf, baby.
807     exit 1
808 }
809
810 h2gm () {
811     if [ "$1" = "client" -o "$1" = "'*'" ]; then echo \'*\'; else
812         ID=`$PDSH $1 $GMNALNID -l | cut -d\  -f2`
813         echo $ID"@gm"
814     fi
815 }
816
817 h2name_or_ip() {
818     if [ "$1" = "client" -o "$1" = "'*'" ]; then echo \'*\'; else
819         echo $1"@$2"
820     fi
821 }
822
823 h2ptl() {
824    if [ "$1" = "client" -o "$1" = "'*'" ]; then echo \'*\'; else
825        ID=`xtprocadmin -n $1 2>/dev/null | egrep -v 'NID' | awk '{print $1}'`
826        if [ -z "$ID" ]; then
827            echo "Could not get a ptl id for $1..."
828            exit 1
829        fi
830        echo $ID"@ptl"
831    fi
832 }
833 declare -fx h2ptl
834
835 h2tcp() {
836     h2name_or_ip "$1" "tcp"
837 }
838 declare -fx h2tcp
839
840 h2elan() {
841     if [ "$1" = "client" -o "$1" = "'*'" ]; then echo \'*\'; else
842         if type __h2elan >/dev/null 2>&1; then
843             ID=$(__h2elan $1)
844         else
845             ID=`echo $1 | sed 's/[^0-9]*//g'`
846         fi
847         echo $ID"@elan"
848     fi
849 }
850 declare -fx h2elan
851
852 h2openib() {
853     h2name_or_ip "$1" "openib"
854 }
855 declare -fx h2openib
856
857 h2o2ib() {
858     h2name_or_ip "$1" "o2ib"
859 }
860 declare -fx h2o2ib
861
862 facet_host() {
863     local facet=$1
864     varname=${facet}_HOST
865     if [ -z "${!varname}" ]; then
866         if [ "${facet:0:3}" == "ost" ]; then
867             eval ${facet}_HOST=${ost_HOST}
868         fi
869     fi
870     echo -n ${!varname}
871 }
872
873 facet_active() {
874     local facet=$1
875     local activevar=${facet}active
876
877     if [ -f $TMP/${facet}active ] ; then
878         source $TMP/${facet}active
879     fi
880
881     active=${!activevar}
882     if [ -z "$active" ] ; then
883         echo -n ${facet}
884     else
885         echo -n ${active}
886     fi
887 }
888
889 facet_active_host() {
890     local facet=$1
891     local active=`facet_active $facet`
892     if [ "$facet" == client ]; then
893         echo $HOSTNAME
894     else
895         echo `facet_host $active`
896     fi
897 }
898
899 change_active() {
900     local facet=$1
901     failover=${facet}failover
902     host=`facet_host $failover`
903     [ -z "$host" ] && return
904     curactive=`facet_active $facet`
905     if [ -z "${curactive}" -o "$curactive" == "$failover" ] ; then
906         eval export ${facet}active=$facet
907     else
908         eval export ${facet}active=$failover
909     fi
910     # save the active host for this facet
911     activevar=${facet}active
912     echo "$activevar=${!activevar}" > $TMP/$activevar
913 }
914
915 do_node() {
916     HOST=$1
917     shift
918     local myPDSH=$PDSH
919     if [ "$HOST" = "$HOSTNAME" ]; then
920         myPDSH="no_dsh"
921     elif [ -z "$myPDSH" -o "$myPDSH" = "no_dsh" ]; then
922         echo "cannot run remote command on $HOST with $myPDSH"
923         return 128
924     fi
925     if $VERBOSE; then
926         echo "CMD: $HOST $@" >&2
927         $myPDSH $HOST $LCTL mark "$@" > /dev/null 2>&1 || :
928     fi
929
930     if [ "$myPDSH" = "rsh" ]; then
931 # we need this because rsh does not return exit code of an executed command
932         local command_status="$TMP/cs"
933         rsh $HOST ":> $command_status"
934         rsh $HOST "(PATH=\$PATH:$RLUSTRE/utils:$RLUSTRE/tests:/sbin:/usr/sbin;
935                     cd $RPWD; sh -c \"$@\") || 
936                     echo command failed >$command_status"
937         [ -n "$($myPDSH $HOST cat $command_status)" ] && return 1 || true
938         return 0
939     fi
940     $myPDSH $HOST "(PATH=\$PATH:$RLUSTRE/utils:$RLUSTRE/tests:/sbin:/usr/sbin; cd $RPWD; sh -c \"$@\")" | sed "s/^${HOST}: //"
941     return ${PIPESTATUS[0]}
942 }
943
944 do_nodes() {
945     local rnodes=$1
946     shift
947
948     # This is part from do_node
949     local myPDSH=$PDSH
950
951     [ -z "$myPDSH" -o "$myPDSH" = "no_dsh" -o "$myPDSH" = "rsh" ] && \
952         echo "cannot run remote command on $rnodes with $myPDSH" && return 128
953
954     if $VERBOSE; then
955         echo "CMD: $rnodes $@" >&2
956         $myPDSH $rnodes $LCTL mark "$@" > /dev/null 2>&1 || :
957     fi
958
959     $myPDSH $rnodes "(PATH=\$PATH:$RLUSTRE/utils:$RLUSTRE/tests:/sbin:/usr/sbin; cd $RPWD; sh -c \"$@\")" | sed -re "s/\w+:\s//g"
960     return ${PIPESTATUS[0]}
961 }
962
963 do_facet() {
964     facet=$1
965     shift
966     HOST=`facet_active_host $facet`
967     [ -z $HOST ] && echo No host defined for facet ${facet} && exit 1
968     do_node $HOST "$@"
969 }
970
971 add() {
972     local facet=$1
973     shift
974     # make sure its not already running
975     stop ${facet} -f
976     rm -f $TMP/${facet}active
977     do_facet ${facet} $MKFS $*
978 }
979
980 ostdevname() {
981     num=$1
982     DEVNAME=OSTDEV$num
983     #if $OSTDEVn isn't defined, default is $OSTDEVBASE + num
984     eval DEVPTR=${!DEVNAME:=${OSTDEVBASE}${num}}
985     echo -n $DEVPTR
986 }
987
988 mdsdevname() {
989     num=$1
990     DEVNAME=MDSDEV$num
991     #if $MDSDEVn isn't defined, default is $MDSDEVBASE + num
992     eval DEVPTR=${!DEVNAME:=${MDSDEVBASE}${num}}
993     echo -n $DEVPTR
994 }
995
996 ########
997 ## MountConf setup
998
999 stopall() {
1000     # make sure we are using the primary server, so test-framework will
1001     # be able to clean up properly.
1002     activemds=`facet_active mds1`
1003     if [ $activemds != "mds1" ]; then
1004         fail mds1
1005     fi
1006
1007     # assume client mount is local
1008     grep " $MOUNT " /proc/mounts && zconf_umount $HOSTNAME $MOUNT $*
1009     grep " $MOUNT2 " /proc/mounts && zconf_umount $HOSTNAME $MOUNT2 $*
1010
1011     if [ -n "$CLIENTS" ]; then
1012             zconf_umount_clients $CLIENTS $MOUNT "$*" || true
1013             [ -n "$MOUNT2" ] && zconf_umount_clients $CLIENTS $MOUNT2 "$*" || true
1014     fi
1015
1016     [ "$CLIENTONLY" ] && return
1017     # The add fn does rm ${facet}active file, this would be enough
1018     # if we use do_facet <facet> only after the facet added, but
1019     # currently we use do_facet mds in local.sh
1020     for num in `seq $MDSCOUNT`; do
1021         stop mds$num -f
1022         rm -f ${TMP}/mds${num}active
1023     done
1024
1025     for num in `seq $OSTCOUNT`; do
1026         stop ost$num -f
1027         rm -f $TMP/ost${num}active
1028     done
1029
1030     return 0
1031 }
1032
1033 cleanupall() {
1034     stopall $*
1035     unload_modules
1036     cleanup_gss
1037 }
1038
1039 mdsmkfsopts()
1040 {
1041     local nr=$1
1042     test $nr = 1 && echo -n $MDS_MKFS_OPTS || echo -n $MDSn_MKFS_OPTS
1043 }
1044
1045 formatall() {
1046     [ "$FSTYPE" ] && FSTYPE_OPT="--backfstype $FSTYPE"
1047
1048     if [ ! -z $SEC ]; then
1049         MDS_MKFS_OPTS="$MDS_MKFS_OPTS --param srpc.flavor.default=$SEC"
1050         OST_MKFS_OPTS="$OST_MKFS_OPTS --param srpc.flavor.default=$SEC"
1051     fi
1052
1053     stopall
1054     # We need ldiskfs here, may as well load them all
1055     load_modules
1056     [ "$CLIENTONLY" ] && return
1057     echo "Formatting mdts, osts"
1058     for num in `seq $MDSCOUNT`; do
1059         echo "Format mds$num: $(mdsdevname $num)"
1060         if $VERBOSE; then
1061             add mds$num `mdsmkfsopts $num` $FSTYPE_OPT --reformat `mdsdevname $num` || exit 9
1062         else
1063             add mds$num `mdsmkfsopts $num` $FSTYPE_OPT --reformat `mdsdevname $num` > /dev/null || exit 9
1064         fi
1065     done
1066
1067     for num in `seq $OSTCOUNT`; do
1068         echo "Format ost$num: $(ostdevname $num)"
1069         if $VERBOSE; then
1070             add ost$num $OST_MKFS_OPTS --reformat `ostdevname $num` || exit 10
1071         else
1072             add ost$num $OST_MKFS_OPTS --reformat `ostdevname $num` > /dev/null || exit 10
1073         fi
1074     done
1075 }
1076
1077 mount_client() {
1078     grep " $1 " /proc/mounts || zconf_mount $HOSTNAME $*
1079 }
1080
1081 umount_client() {
1082     grep " $1 " /proc/mounts && zconf_umount `hostname` $*
1083 }
1084
1085 # return value:
1086 # 0: success, the old identity set already.
1087 # 1: success, the old identity does not set.
1088 # 2: fail.
1089 switch_identity() {
1090     local num=$1
1091     local switch=$2
1092     local j=`expr $num - 1`
1093     local MDT="`do_facet mds$num lctl get_param -N mdt.*MDT*$j | cut -d"." -f2 2>/dev/null || true`"
1094
1095     if [ -z "$MDT" ]; then
1096         return 2
1097     fi
1098
1099     local old="`do_facet mds$num "lctl get_param -n mdt.$MDT.identity_upcall"`"
1100
1101     if $switch; then
1102         do_facet mds$num "lctl set_param -n mdt.$MDT.identity_upcall \"$L_GETIDENTITY\""
1103     else
1104         do_facet mds$num "lctl set_param -n mdt.$MDT.identity_upcall \"NONE\""
1105     fi
1106
1107     do_facet mds$num "lctl set_param -n mdt/$MDT/identity_flush \"-1\""
1108
1109     if [ $old = "NONE" ]; then
1110         return 1
1111     else
1112         return 0
1113     fi
1114 }
1115
1116 remount_client()
1117 {
1118         zconf_umount `hostname` $1 || error "umount failed"
1119         zconf_mount `hostname` $1 || error "mount failed"
1120 }
1121
1122 set_obd_timeout() {
1123     local facet=$1
1124     local timeout=$2
1125
1126     do_facet $facet lsmod | grep -q obdclass || \
1127         do_facet $facet "modprobe obdclass"
1128
1129     do_facet $facet "lctl set_param timeout=$timeout"
1130 }
1131
1132 setupall() {
1133     load_modules
1134     init_gss
1135     if [ -z "$CLIENTONLY" ]; then
1136         echo "Setup mdts, osts"
1137         for num in `seq $MDSCOUNT`; do
1138             DEVNAME=$(mdsdevname $num)
1139             echo $REFORMAT | grep -q "reformat" \
1140             || do_facet mds$num "$TUNEFS --writeconf $DEVNAME"
1141             set_obd_timeout mds$num $TIMEOUT
1142             start mds$num $DEVNAME $MDS_MOUNT_OPTS
1143
1144             # We started mds, now we should set failover variables properly.
1145             # Set mds${num}failover_HOST if it is not set (the default failnode).
1146             local varname=mds${num}failover_HOST
1147             if [ -z "${!varname}" ]; then
1148                 eval mds${num}failover_HOST=$(facet_host mds$num)
1149             fi
1150
1151             if [ $IDENTITY_UPCALL != "default" ]; then
1152                 switch_identity $num $IDENTITY_UPCALL
1153             fi
1154         done
1155         for num in `seq $OSTCOUNT`; do
1156             DEVNAME=$(ostdevname $num)
1157             set_obd_timeout ost$num $TIMEOUT
1158             start ost$num $DEVNAME $OST_MOUNT_OPTS
1159
1160             # We started ost$num, now we should set ost${num}failover variable properly.
1161             # Set ost${num}failover_HOST if it is not set (the default failnode).
1162             varname=ost${num}failover_HOST
1163             if [ -z "${!varname}" ]; then
1164                 eval ost${num}failover_HOST=$(facet_host ost${num})
1165             fi
1166
1167         done
1168     fi
1169     [ "$DAEMONFILE" ] && $LCTL debug_daemon start $DAEMONFILE $DAEMONSIZE
1170     mount_client $MOUNT
1171     [ -n "$CLIENTS" ] && zconf_mount_clients $CLIENTS $MOUNT
1172
1173     if [ "$MOUNT_2" ]; then
1174         mount_client $MOUNT2
1175         [ -n "$CLIENTS" ] && zconf_mount_clients $CLIENTS $MOUNT2
1176     fi
1177
1178     # by remounting mdt before ost, initial connect from mdt to ost might
1179     # timeout because ost is not ready yet. wait some time to its fully
1180     # recovery. initial obd_connect timeout is 5s; in GSS case it's preceeded
1181     # by a context negotiation rpc with $TIMEOUT.
1182     # FIXME better by monitoring import status.
1183     if $GSS; then
1184         sleep $((TIMEOUT + 5))
1185     else
1186         sleep 5
1187     fi
1188 }
1189
1190 mounted_lustre_filesystems() {
1191         awk '($3 ~ "lustre" && $1 ~ ":") { print $2 }' /proc/mounts
1192 }
1193
1194 check_and_setup_lustre() {
1195     MOUNTED="`mounted_lustre_filesystems`"
1196     if [ -z "$MOUNTED" ]; then
1197         [ "$REFORMAT" ] && formatall
1198         setupall
1199         MOUNTED="`mounted_lustre_filesystems`"
1200         [ -z "$MOUNTED" ] && error "NAME=$NAME not mounted"
1201         export I_MOUNTED=yes
1202     fi
1203     if [ "$ONLY" == "setup" ]; then
1204         exit 0
1205     fi
1206 }
1207
1208 cleanup_and_setup_lustre() {
1209     if [ "$ONLY" == "cleanup" -o "`mount | grep $MOUNT`" ]; then
1210         lctl set_param debug=0 || true
1211         cleanupall
1212         if [ "$ONLY" == "cleanup" ]; then
1213             exit 0
1214         fi
1215     fi
1216     check_and_setup_lustre
1217 }
1218
1219 check_and_cleanup_lustre() {
1220     if [ "`mount | grep $MOUNT`" ]; then
1221         [ -n "$DIR" ] && rm -rf $DIR/[Rdfs][0-9]*
1222     fi
1223     if [ "$I_MOUNTED" = "yes" ]; then
1224         cleanupall -f || error "cleanup failed"
1225     fi
1226     unset I_MOUNTED
1227 }
1228
1229 #######
1230 # General functions
1231
1232 check_network() {
1233     local NETWORK=0
1234     local WAIT=0
1235     local MAX=$2
1236     while [ $NETWORK -eq 0 ]; do
1237         ping -c 1 -w 3 $1 > /dev/null
1238         if [ $? -eq 0 ]; then
1239             NETWORK=1
1240         else
1241             WAIT=$((WAIT + 5))
1242             echo "waiting for $1, $((MAX - WAIT)) secs left"
1243             sleep 5
1244         fi
1245         if [ $WAIT -gt $MAX ]; then
1246             echo "Network not available"
1247             exit 1
1248         fi
1249     done
1250 }
1251 check_port() {
1252     while( !($DSH2 $1 "netstat -tna | grep -q $2") ) ; do
1253         sleep 9
1254     done
1255 }
1256
1257 no_dsh() {
1258     shift
1259     eval $@
1260 }
1261
1262 comma_list() {
1263     # the sed converts spaces to commas, but leaves the last space
1264     # alone, so the line doesn't end with a comma.
1265     echo "$*" | tr -s " " "\n" | sort -b -u | tr "\n" " " | sed 's/ \([^$]\)/,\1/g'
1266 }
1267
1268 absolute_path() {
1269     (cd `dirname $1`; echo $PWD/`basename $1`)
1270 }
1271
1272 ##################################
1273 # Adaptive Timeouts funcs
1274
1275 at_is_valid() {
1276     if [ -z "$AT_MAX_PATH" ]; then
1277         AT_MAX_PATH=$(do_facet mds "find /sys/ -name at_max")
1278         [ -z "$AT_MAX_PATH" ] && echo "missing /sys/.../at_max " && return 1
1279     fi
1280     return 0
1281 }
1282
1283 at_is_enabled() {
1284     at_is_valid || error "invalid call"
1285
1286     # only check mds, we assume at_max is the same on all nodes
1287     local at_max=$(do_facet mds "cat $AT_MAX_PATH")
1288     if [ $at_max -eq 0 ]; then
1289         return 1
1290     else
1291         return 0
1292     fi
1293 }
1294
1295 at_max_get() {
1296     at_is_valid || error "invalid call"
1297
1298     do_facet $1 "cat $AT_MAX_PATH"
1299 }
1300
1301 at_max_set() {
1302     local at_max=$1
1303     shift
1304
1305     at_is_valid || error "invalid call"
1306
1307     for facet in $@; do
1308         if [ $facet == "ost" ]; then
1309             for i in `seq $OSTCOUNT`; do
1310                 do_facet ost$i "echo $at_max > $AT_MAX_PATH"
1311             done
1312         elif [ $facet == "mds" ]; then
1313             for i in `seq $MDSCOUNT`; do
1314                 do_facet mds$i "echo $at_max > $AT_MAX_PATH"
1315             done
1316         else
1317             do_facet $facet "echo $at_max > $AT_MAX_PATH"
1318         fi
1319     done
1320 }
1321
1322 ##################################
1323 # OBD_FAIL funcs
1324
1325 drop_request() {
1326 # OBD_FAIL_MDS_ALL_REQUEST_NET
1327     RC=0
1328     do_facet mds lctl set_param fail_loc=0x123
1329     do_facet client "$1" || RC=$?
1330     do_facet mds lctl set_param fail_loc=0
1331     return $RC
1332 }
1333
1334 drop_reply() {
1335 # OBD_FAIL_MDS_ALL_REPLY_NET
1336     RC=0
1337     do_facet mds lctl set_param fail_loc=0x122
1338     do_facet client "$@" || RC=$?
1339     do_facet mds lctl set_param fail_loc=0
1340     return $RC
1341 }
1342
1343 drop_reint_reply() {
1344 # OBD_FAIL_MDS_REINT_NET_REP
1345     RC=0
1346     do_facet mds lctl set_param fail_loc=0x119
1347     do_facet client "$@" || RC=$?
1348     do_facet mds lctl set_param fail_loc=0
1349     return $RC
1350 }
1351
1352 pause_bulk() {
1353 #define OBD_FAIL_OST_BRW_PAUSE_BULK      0x214
1354     RC=0
1355     do_facet ost1 lctl set_param fail_loc=0x214
1356     do_facet client "$1" || RC=$?
1357     do_facet client "sync"
1358     do_facet ost1 lctl set_param fail_loc=0
1359     return $RC
1360 }
1361
1362 drop_ldlm_cancel() {
1363 #define OBD_FAIL_LDLM_CANCEL             0x304
1364     RC=0
1365     do_facet client lctl set_param fail_loc=0x304
1366     do_facet client "$@" || RC=$?
1367     do_facet client lctl set_param fail_loc=0
1368     return $RC
1369 }
1370
1371 drop_bl_callback() {
1372 #define OBD_FAIL_LDLM_BL_CALLBACK        0x305
1373     RC=0
1374     do_facet client lctl set_param fail_loc=0x305
1375     do_facet client "$@" || RC=$?
1376     do_facet client lctl set_param fail_loc=0
1377     return $RC
1378 }
1379
1380 drop_ldlm_reply() {
1381 #define OBD_FAIL_LDLM_REPLY              0x30c
1382     RC=0
1383     do_facet mds lctl set_param fail_loc=0x30c
1384     do_facet client "$@" || RC=$?
1385     do_facet mds lctl set_param fail_loc=0
1386     return $RC
1387 }
1388
1389 clear_failloc() {
1390     facet=$1
1391     pause=$2
1392     sleep $pause
1393     echo "clearing fail_loc on $facet"
1394     do_facet $facet "lctl set_param fail_loc=0 2>/dev/null || true"
1395 }
1396
1397 set_nodes_failloc () {
1398     local nodes=$1
1399     local node
1400
1401     for node in $nodes ; do
1402         do_node $node lctl set_param fail_loc=$2
1403     done
1404 }
1405
1406 set_nodes_failloc () {
1407     local nodes=$1
1408     local node
1409
1410     for node in $nodes ; do
1411         do_node $node lctl set_param fail_loc=$2
1412     done
1413 }
1414
1415 cancel_lru_locks() {
1416     $LCTL mark "cancel_lru_locks $1 start"
1417     for d in `lctl get_param -N ldlm.namespaces.*.lru_size | egrep -i $1`; do
1418         $LCTL set_param -n $d=clear
1419     done
1420     $LCTL get_param ldlm.namespaces.*.lock_unused_count | egrep -i $1 | grep -v '=0'
1421     $LCTL mark "cancel_lru_locks $1 stop"
1422 }
1423
1424 default_lru_size()
1425 {
1426         NR_CPU=$(grep -c "processor" /proc/cpuinfo)
1427         DEFAULT_LRU_SIZE=$((100 * NR_CPU))
1428         echo "$DEFAULT_LRU_SIZE"
1429 }
1430
1431 lru_resize_enable()
1432 {
1433     lctl set_param ldlm.namespaces.*$1*.lru_size=0
1434 }
1435
1436 lru_resize_disable()
1437 {
1438     lctl set_param ldlm.namespaces.*$1*.lru_size $(default_lru_size)
1439 }
1440
1441 pgcache_empty() {
1442     local FILE
1443     for FILE in `lctl get_param -N "llite.*.dump_page_cache"`; do
1444         if [ `lctl get_param -n $FILE | wc -l` -gt 1 ]; then
1445             echo there is still data in page cache $FILE ?
1446             lctl get_param -n $FILE
1447             return 1
1448         fi
1449     done
1450     return 0
1451 }
1452
1453 debugsave() {
1454     DEBUGSAVE="$(lctl get_param -n debug)"
1455 }
1456
1457 debugrestore() {
1458     [ -n "$DEBUGSAVE" ] && lctl set_param debug="${DEBUGSAVE}"
1459     DEBUGSAVE=""
1460 }
1461
1462 ##################################
1463 # Test interface
1464 ##################################
1465
1466 error_noexit() {
1467     local TYPE=${TYPE:-"FAIL"}
1468     local ERRLOG
1469     lctl set_param fail_loc=0 2>/dev/null || true
1470     log " ${TESTSUITE} ${TESTNAME}: @@@@@@ ${TYPE}: $@ "
1471     ERRLOG=$TMP/lustre_${TESTSUITE}_${TESTNAME}.$(date +%s)
1472     echo "Dumping lctl log to $ERRLOG"
1473     # We need to dump the logs on all nodes
1474     local NODES=$(nodes_list)
1475     for NODE in $NODES; do
1476         do_node $NODE $LCTL dk $ERRLOG
1477     done
1478     debugrestore
1479     [ "$TESTSUITELOG" ] && echo "$0: ${TYPE}: $TESTNAME $@" >> $TESTSUITELOG
1480 }
1481
1482 error() {
1483     error_noexit "$@"
1484     $FAIL_ON_ERROR && exit 1 || true
1485 }
1486
1487 error_exit() {
1488     error_noexit "$@"
1489     exit 1
1490 }
1491
1492 # use only if we are ignoring failures for this test, bugno required.
1493 # (like ALWAYS_EXCEPT, but run the test and ignore the results.)
1494 # e.g. error_ignore 5494 "your message"
1495 error_ignore() {
1496     local TYPE="IGNORE (bz$1)"
1497     shift
1498     error_noexit "$@"
1499 }
1500
1501 skip () {
1502         log " SKIP: ${TESTSUITE} ${TESTNAME} $@"
1503         [ "$TESTSUITELOG" ] && echo "${TESTSUITE}: SKIP: $TESTNAME $@" >> $TESTSUITELOG
1504 }
1505
1506 build_test_filter() {
1507     [ "$ONLY" ] && log "only running test `echo $ONLY`"
1508     for O in $ONLY; do
1509         eval ONLY_${O}=true
1510     done
1511     [ "$EXCEPT$ALWAYS_EXCEPT" ] && \
1512         log "excepting tests: `echo $EXCEPT $ALWAYS_EXCEPT`"
1513     [ "$EXCEPT_SLOW" ] && \
1514         log "skipping tests SLOW=no: `echo $EXCEPT_SLOW`"
1515     for E in $EXCEPT $ALWAYS_EXCEPT; do
1516         eval EXCEPT_${E}=true
1517     done
1518     for E in $EXCEPT_SLOW; do
1519         eval EXCEPT_SLOW_${E}=true
1520     done
1521     for G in $GRANT_CHECK_LIST; do
1522         eval GCHECK_ONLY_${G}=true
1523         done
1524 }
1525
1526 _basetest() {
1527     echo $*
1528 }
1529
1530 basetest() {
1531     IFS=abcdefghijklmnopqrstuvwxyz _basetest $1
1532 }
1533
1534 run_test() {
1535     assert_DIR
1536
1537     export base=`basetest $1`
1538     if [ ! -z "$ONLY" ]; then
1539         testname=ONLY_$1
1540         if [ ${!testname}x != x ]; then
1541             run_one $1 "$2"
1542             return $?
1543         fi
1544         testname=ONLY_$base
1545         if [ ${!testname}x != x ]; then
1546             run_one $1 "$2"
1547             return $?
1548         fi
1549         echo -n "."
1550         return 0
1551     fi
1552     testname=EXCEPT_$1
1553     if [ ${!testname}x != x ]; then
1554         TESTNAME=test_$1 skip "skipping excluded test $1"
1555         return 0
1556     fi
1557     testname=EXCEPT_$base
1558     if [ ${!testname}x != x ]; then
1559         TESTNAME=test_$1 skip "skipping excluded test $1 (base $base)"
1560         return 0
1561     fi
1562     testname=EXCEPT_SLOW_$1
1563     if [ ${!testname}x != x ]; then
1564         TESTNAME=test_$1 skip "skipping SLOW test $1"
1565         return 0
1566     fi
1567     testname=EXCEPT_SLOW_$base
1568     if [ ${!testname}x != x ]; then
1569         TESTNAME=test_$1 skip "skipping SLOW test $1 (base $base)"
1570         return 0
1571     fi
1572
1573     run_one $1 "$2"
1574
1575     return $?
1576 }
1577
1578 EQUALS="======================================================================"
1579 equals_msg() {
1580     msg="$@"
1581
1582     local suffixlen=$((${#EQUALS} - ${#msg}))
1583     [ $suffixlen -lt 5 ] && suffixlen=5
1584     log `echo $(printf '===== %s %.*s\n' "$msg" $suffixlen $EQUALS)`
1585 }
1586
1587 log() {
1588     echo "$*"
1589     lsmod | grep lnet > /dev/null || load_modules
1590
1591     local MSG="$*"
1592     # Get rif of '
1593     MSG=${MSG//\'/\\\'}
1594     MSG=${MSG//\(/\\\(}
1595     MSG=${MSG//\)/\\\)}
1596     MSG=${MSG//\;/\\\;}
1597     MSG=${MSG//\|/\\\|}
1598     MSG=${MSG//\>/\\\>}
1599     MSG=${MSG//\</\\\<}
1600     local NODES=$(nodes_list)
1601     for NODE in $NODES; do
1602         do_node $NODE $LCTL mark "$MSG" 2> /dev/null || true
1603     done
1604 }
1605
1606 trace() {
1607         log "STARTING: $*"
1608         strace -o $TMP/$1.strace -ttt $*
1609         RC=$?
1610         log "FINISHED: $*: rc $RC"
1611         return 1
1612 }
1613
1614 pass() {
1615     echo PASS $@
1616 }
1617
1618 check_mds() {
1619     FFREE=`lctl get_param -n osd.*MDT*.filesfree`
1620     FTOTAL=`lctl get_param -n osd.*MDT*.filestotal`
1621     [ $FFREE -ge $FTOTAL ] && error "files free $FFREE > total $FTOTAL" || true
1622 }
1623
1624 reset_fail_loc () {
1625     local myNODES=$(nodes_list)
1626     local NODE
1627
1628     for NODE in $myNODES; do
1629         do_node $NODE "lctl set_param fail_loc=0 2>/dev/null || true"
1630     done
1631 }
1632
1633 run_one() {
1634     testnum=$1
1635     message=$2
1636     tfile=f${testnum}
1637     export tdir=d0.${TESTSUITE}/d${base}
1638     local SAVE_UMASK=`umask`
1639     umask 0022
1640
1641     BEFORE=`date +%s`
1642     log "== test $testnum: $message ============ `date +%H:%M:%S` ($BEFORE)"
1643     #check_mds
1644     export TESTNAME=test_$testnum
1645     test_${testnum} || error "test_$testnum failed with $?"
1646     #check_mds
1647     cd $SAVE_PWD
1648     reset_fail_loc
1649     check_grant ${testnum} || error "check_grant $testnum failed with $?"
1650     [ -f $CATASTROPHE ] && [ `cat $CATASTROPHE` -ne 0 ] && \
1651         error "LBUG/LASSERT detected"
1652     ps auxww | grep -v grep | grep -q multiop && error "multiop still running"
1653     pass "($((`date +%s` - $BEFORE))s)"
1654     unset TESTNAME
1655     unset tdir
1656     umask $SAVE_UMASK
1657     $CLEANUP
1658 }
1659
1660 canonical_path() {
1661     (cd `dirname $1`; echo $PWD/`basename $1`)
1662 }
1663
1664 sync_clients() {
1665     [ -d $DIR1 ] && cd $DIR1 && sync; sleep 1; sync
1666     [ -d $DIR2 ] && cd $DIR2 && sync; sleep 1; sync
1667         cd $SAVE_PWD
1668 }
1669
1670 check_grant() {
1671     export base=`basetest $1`
1672     [ "$CHECK_GRANT" == "no" ] && return 0
1673
1674         testname=GCHECK_ONLY_${base}
1675         [ ${!testname}x == x ] && return 0
1676
1677     echo -n "checking grant......"
1678         cd $SAVE_PWD
1679         # write some data to sync client lost_grant
1680         rm -f $DIR1/${tfile}_check_grant_* 2>&1
1681         for i in `seq $OSTCOUNT`; do
1682                 $LFS setstripe $DIR1/${tfile}_check_grant_$i -i $(($i -1)) -c 1
1683                 dd if=/dev/zero of=$DIR1/${tfile}_check_grant_$i bs=4k \
1684                                               count=1 > /dev/null 2>&1
1685         done
1686         # sync all the data and make sure no pending data on server
1687         sync_clients
1688         
1689         #get client grant and server grant
1690         client_grant=0
1691     for d in `lctl get_param -n osc.*.cur_grant_bytes`; do
1692                 client_grant=$((client_grant + $d))
1693         done
1694         server_grant=0
1695         for d in `lctl get_param -n obdfilter.*.tot_granted`; do
1696                 server_grant=$((server_grant + $d))
1697         done
1698
1699         # cleanup the check_grant file
1700         for i in `seq $OSTCOUNT`; do
1701                 rm $DIR1/${tfile}_check_grant_$i
1702         done
1703
1704         #check whether client grant == server grant
1705         if [ $client_grant != $server_grant ]; then
1706                 echo "failed: client:${client_grant} server: ${server_grant}"
1707                 return 1
1708         else
1709                 echo "pass"
1710         fi
1711 }
1712
1713 ########################
1714 # helper functions
1715
1716 osc_to_ost()
1717 {
1718     osc=$1
1719     ost=`echo $1 | awk -F_ '{print $3}'`
1720     if [ -z $ost ]; then
1721         ost=`echo $1 | sed 's/-osc.*//'`
1722     fi
1723     echo $ost
1724 }
1725
1726 remote_mds ()
1727 {
1728     [ -z "$(lctl dl | grep mdt)" ]
1729 }
1730
1731 remote_mds_nodsh()
1732 {
1733     remote_mds && [ "$PDSH" = "no_dsh" -o -z "$PDSH" -o -z "$mds_HOST" ]
1734 }
1735
1736 remote_ost ()
1737 {
1738     [ -z "$(lctl dl | grep ost)" ]
1739 }
1740
1741 remote_ost_nodsh()
1742 {
1743     remote_ost && [ "$PDSH" = "no_dsh" -o -z "$PDSH" -o -z "$ost_HOST" ]
1744 }
1745
1746 mdts_nodes () {
1747     local MDSNODES=$(facet_host $SINGLEMDS)
1748     local NODES_sort
1749
1750     # FIXME: Currenly we use only $SINGLEMDS,
1751     # should be fixed when we will start to test cmd.
1752     echo $MDSNODES
1753     return
1754
1755     for num in `seq $MDSCOUNT`; do
1756         local myMDS=$(facet_host mds$num)
1757         MDSNODES="$MDSNODES $myMDS"
1758     done
1759     NODES_sort=$(for i in $MDSNODES; do echo $i; done | sort -u)
1760
1761     echo $NODES_sort
1762 }
1763
1764 osts_nodes () {
1765     local OSTNODES=$(facet_host ost1)
1766     local NODES_sort
1767
1768     for num in `seq $OSTCOUNT`; do
1769         local myOST=$(facet_host ost$num)
1770         OSTNODES="$OSTNODES $myOST"
1771     done
1772     NODES_sort=$(for i in $OSTNODES; do echo $i; done | sort -u)
1773
1774     echo $NODES_sort
1775 }
1776
1777 nodes_list () {
1778     # FIXME. We need a list of clients
1779     local myNODES=$HOSTNAME
1780     local myNODES_sort
1781
1782     # CLIENTS (if specified) contains the local client
1783     [ -n "$CLIENTS" ] && myNODES=${CLIENTS//,/ }
1784
1785     if [ "$PDSH" -a "$PDSH" != "no_dsh" ]; then
1786         myNODES="$myNODES $(osts_nodes) $(mdts_nodes)"
1787     fi
1788
1789     myNODES_sort=$(for i in $myNODES; do echo $i; done | sort -u)
1790
1791     echo $myNODES_sort
1792 }
1793
1794 init_clients_lists () {
1795     # Sanity check: exclude the local client from RCLIENTS
1796     local rclients=$(echo " $RCLIENTS " | sed -re "s/\s+$HOSTNAME\s+/ /g")
1797
1798     # Sanity check: exclude the dup entries
1799     rclients=$(for i in $rclients; do echo $i; done | sort -u)
1800
1801     local clients="$SINGLECLIENT $HOSTNAME $rclients"
1802
1803     # Sanity check: exclude the dup entries from CLIENTS
1804     # for those configs which has SINGLCLIENT set to local client 
1805     clients=$(for i in $clients; do echo $i; done | sort -u)
1806
1807     CLIENTS=`comma_list $clients`
1808     local -a remoteclients=($rclients)
1809     for ((i=0; $i<${#remoteclients[@]}; i++)); do
1810             varname=CLIENT$((i + 2))
1811             eval $varname=${remoteclients[i]}
1812     done
1813
1814     CLIENTCOUNT=$((${#remoteclients[@]} + 1))
1815 }
1816
1817 is_patchless ()
1818 {
1819     lctl get_param version | grep -q patchless
1820 }
1821
1822 get_node_count() {
1823    local nodes="$@"
1824    echo $nodes | wc -w || true
1825 }
1826
1827 mixed_ost_devs () {
1828     local nodes=$(osts_nodes)
1829     local osscount=$(get_node_count "$nodes")
1830     [ ! "$OSTCOUNT" = "$osscount" ]
1831 }
1832
1833 check_runas_id_ret() {
1834     local myRC=0
1835     local myRUNAS_ID=$1
1836     shift
1837     local myRUNAS=$@
1838     if [ -z "$myRUNAS" ]; then
1839         error_exit "myRUNAS command must be specified for check_runas_id"
1840     fi
1841     if $GSS_KRB5; then
1842         $myRUNAS krb5_login.sh || \
1843             error "Failed to refresh Kerberos V5 TGT for UID $myRUNAS_ID."
1844     fi
1845     mkdir $DIR/d0_runas_test
1846     chmod 0755 $DIR
1847     chown $myRUNAS_ID:$myRUNAS_ID $DIR/d0_runas_test
1848     $myRUNAS touch $DIR/d0_runas_test/f$$ || myRC=$?
1849     rm -rf $DIR/d0_runas_test
1850     return $myRC
1851 }
1852
1853 check_runas_id() {
1854     local myRUNAS_ID=$1
1855     shift
1856     local myRUNAS=$@
1857     check_runas_id_ret $myRUNAS_ID $myRUNAS || \
1858         error "unable to write to $DIR/d0_runas_test as UID $myRUNAS_ID. 
1859         Please set RUNAS_ID to some UID which exists on MDS and client or 
1860         add user $myRUNAS_ID:$myRUNAS_ID on these nodes."
1861 }
1862
1863 # Run multiop in the background, but wait for it to print
1864 # "PAUSING" to its stdout before returning from this function.
1865 multiop_bg_pause() {
1866     MULTIOP_PROG=${MULTIOP_PROG:-multiop}
1867     FILE=$1
1868     ARGS=$2
1869
1870     TMPPIPE=/tmp/multiop_open_wait_pipe.$$
1871     mkfifo $TMPPIPE
1872
1873     echo "$MULTIOP_PROG $FILE v$ARGS"
1874     $MULTIOP_PROG $FILE v$ARGS > $TMPPIPE &
1875
1876     echo "TMPPIPE=${TMPPIPE}"
1877     read -t 60 multiop_output < $TMPPIPE
1878     if [ $? -ne 0 ]; then
1879         rm -f $TMPPIPE
1880         return 1
1881     fi
1882     rm -f $TMPPIPE
1883     if [ "$multiop_output" != "PAUSING" ]; then
1884         echo "Incorrect multiop output: $multiop_output"
1885         kill -9 $PID
1886         return 1
1887     fi
1888
1889     return 0
1890 }
1891
1892 # reset llite stat counters
1893 clear_llite_stats(){
1894         lctl set_param -n llite.*.stats 0
1895 }
1896
1897 # sum llite stat items
1898 calc_llite_stats() {
1899         local res=$(lctl get_param -n llite.*.stats |
1900                     awk 'BEGIN {s = 0} END {print s} /^'"$1"'/ {s += $2}')
1901         echo $res
1902 }
1903
1904 # save_lustre_params(node, parameter_mask)
1905 # generate a stream of formatted strings (<node> <param name>=<param value>)
1906 save_lustre_params() {
1907         local s
1908         do_node $1 "lctl get_param $2" | while read s; do echo "$1 $s"; done
1909 }
1910
1911 # restore lustre parameters from input stream, produces by save_lustre_params
1912 restore_lustre_params() {
1913         local node
1914         local name
1915         local val
1916         while IFS=" =" read node name val; do
1917                 do_node $node "lctl set_param -n $name $val"
1918         done
1919 }
1920